<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_ehr_communication_queue".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnEhrCommunicationQueue".
 *
 * Columns in table "cpn_ehr_communication_queue" available as properties of the model,
 * followed by relations of table "cpn_ehr_communication_queue" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property integer $cpn_ehr_message_type_id
 * @property integer $cpn_installation_id
 * @property integer $cpn_ehr_installation_id
 * @property string $endpoint
 * @property integer $processed
 * @property integer $success
 * @property integer $del_flag
 * @property string $message_identifier
 * @property string $message
 * @property string $results
 * @property string $entity_type
 * @property string $entity_value
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property CpnEhrMessageType $cpnEhrMessageType
 * @property Account $addedByAccount
 * @property CpnInstallation $cpnInstallation
 */
// IMPORTANT: This model does not inherit from BaseModel because we don't
// want this information to go to PDI.
// It is correct for it to inherit directly from GxActiveRecord
abstract class BaseCpnEhrCommunicationQueue extends GxActiveRecord
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_ehr_communication_queue';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnEhrCommunicationQueue|CpnEhrCommunicationQueues', $n);
    }

    public static function representingColumn()
    {
        return 'message_identifier';
    }

    public function rules()
    {
        return array(
            array('cpn_ehr_message_type_id, cpn_installation_id, cpn_ehr_installation_id, message_identifier, '
                . 'added_by_account_id', 'required'),
            array('cpn_ehr_message_type_id, cpn_installation_id, cpn_ehr_installation_id, processed, success, '
                . 'del_flag, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid, message_identifier', 'length', 'max' => 255),
            array('endpoint', 'length', 'max' => 5),
            array('entity_type', 'length', 'max' => 40),
            array('entity_value', 'length', 'max' => 20),
            array('message, results, date_added, date_updated', 'safe'),
            array('guid, endpoint, processed, success, del_flag, message, results, entity_type, entity_value, '
                . 'date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, guid, cpn_ehr_message_type_id, cpn_installation_id, cpn_ehr_installation_id, endpoint, '
                . 'processed, success, del_flag, message_identifier, message, results, entity_type, entity_value, '
                . 'date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnEhrMessageType' => array(self::BELONGS_TO, 'CpnEhrMessageType', 'cpn_ehr_message_type_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnInstallation' => array(self::BELONGS_TO, 'CpnInstallation', 'cpn_installation_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'cpn_ehr_message_type_id' => null,
            'cpn_installation_id' => null,
            'cpn_ehr_installation_id' => Yii::t('app', 'Cpn Ehr Installation'),
            'endpoint' => Yii::t('app', 'Endpoint'),
            'processed' => Yii::t('app', 'Processed'),
            'success' => Yii::t('app', 'Success'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'message_identifier' => Yii::t('app', 'Message Identifier'),
            'message' => Yii::t('app', 'Message'),
            'results' => Yii::t('app', 'Results'),
            'entity_type' => Yii::t('app', 'Entity Type'),
            'entity_value' => Yii::t('app', 'Entity Value'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'cpnEhrMessageType' => null,
            'addedByAccount' => null,
            'cpnInstallation' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('cpn_ehr_message_type_id', $this->cpn_ehr_message_type_id);
        $criteria->compare('cpn_installation_id', $this->cpn_installation_id);
        $criteria->compare('cpn_ehr_installation_id', $this->cpn_ehr_installation_id);
        $criteria->compare('endpoint', $this->endpoint, true);
        $criteria->compare('processed', $this->processed);
        $criteria->compare('success', $this->success);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('message_identifier', $this->message_identifier, true);
        $criteria->compare('message', $this->message, true);
        $criteria->compare('results', $this->results, true);
        $criteria->compare('entity_type', $this->entity_type, true);
        $criteria->compare('entity_value', $this->entity_value, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Automatically generate creation date if necessary.
     * @internal Remember to call parent::beforeSave() when overriding beforeSave
     */
    protected function beforeSave()
    {

        $currentDate = date('Y-m-d H:i:s');

        // set date_added if that field exists and this is a new record
        if ($this->isNewRecord &&
                ($this->hasAttribute('date_added') || property_exists(get_called_class(), 'date_added'))) {

            if (empty($this->date_added) || $this->date_added == '0000-00-00 00:00:00' || $this->date_added == 'CURRENT_TIMESTAMP') {
                $this->date_added = $currentDate;
            }
        }

        // set date_updated if that field exists
        if ($this->hasAttribute('date_updated') ||
                property_exists(get_called_class(), 'date_updated')) {
            if (empty($this->date_updated)) {
                $this->date_updated = $currentDate;
            }
        }

        return parent::beforeSave();
    }

    /**
     * Checks if notifications should be sent to partners.
     * @return boolean
     */
    public function pdiDisabled()
    {
        return true;
    }

}
